<?php

/**
 * Plugin Name:Coin Market Cap By ScriptYab
 * Description:Create a website similar like CoinMarketCap.com using this <strong>Coin Market Cap & Crypto Prices</strong> WordPress plugin. This crypto plugin uses coinmarketcap.com api to grab live crypto prices, market cap, charts and other data related to cryptocurrency
 * Plugin URI:https://scriptyab.com/downlaod-coin-market-cap-3-6-5/
 * Author:Cool Plugins 
 * Author URI:https://coolplugins.net/
 * Version:3.6.5
 * License: GPL2
 * Text Domain:cmc
 * Domain Path:languages
 **/


 /**
 * This Plugin Downloaded From ScriptYAB.com
 *Copyright (C) 2016 CoolPlugins contact@coolplugins.net
 */

if (!defined('ABSPATH')) {
	exit();
}
	
define('CMC', '3.6.5');
define('CMC_PRO_FILE', __FILE__);
define('CMC_PATH', plugin_dir_path(CMC_PRO_FILE ));
define('CMC_PLUGIN_DIR',plugin_dir_path(CMC_PRO_FILE ));
define( 'CMC_URL',plugin_dir_url(CMC_PRO_FILE ));
define('CMC_LOAD_COINS',1800);

define('CMC_API_ENDPOINT',"https://api-beta.coinexchangeprice.com/v1/");
if( !defined('CMC_CSS_URL')) {
    define('CMC_CSS_URL', plugin_dir_url( __FILE__ ) . 'css');
}

/**
 * Class CoinMarketCap
 */
final class CoinMarketCap {

	/**
	 * Plugin instance.
	 *
	 *
	 * @access private
	 */
	private static $instance = null;
	public $shortcode_obj=null;

	/**
	 * Get plugin instance.
	 *
	 *
	 * @static
	 */
	public static function get_instance() {
		if ( ! isset( self::$instance ) ) {
			self::$instance = new self;
		}
		return self::$instance;
	}

	/**
	 * Constructor.
	 *
	 * @access private
	 */
	private function __construct() {
		//set_time_limit(120);
		
		$this->cmc_installation_date();
		$this->cmc_includes();
	   register_activation_hook( CMC_PRO_FILE, array( $this, 'cmc_activate' ) );
	   register_deactivation_hook( CMC_PRO_FILE, array( $this, 'cmc_deactivate' ) );
	   add_filter( 'style_loader_tag', array( $this, 'cmc_css_preload') , 10, 4 );
	   add_filter( 'script_loader_tag', array( $this, 'cmc_defer_scripts' ), 10, 3 );
	//    add_action( 'tf_done', array( $this, 'cmc_save_coins_details_page_id' ) );
	  // run to verify plugin version in-case of update
	   add_action( 'init', array($this,'cmc_plugin_version_verify') );
	   add_action( 'plugins_loaded', array( $this, 'cmc_init' ) );
	   // creating settings panel
	    add_action( 'tf_create_options', array( $this,'cmc_createMyOptions'));
	  	// registering post type for generator
		add_action( 'init',  array( $this,'cmc_post_type') );
		
		// coin custom description post type
		add_action( 'init',  array( $this,'cmc_description_post_type'),11 );

		// registering custom rewrite urls for coin single pge
		 add_action('init', array($this, 'cmc_rewrite_rule'));
		add_filter( 'query_vars', array($this,'cmc_query_vars'));

		add_action('tf_save_admin_cmc_single_settings', array($this, 'cmc_after_titan_save'), 10, 3);

		add_filter('display_post_states', array($this, 'cmc_generted_page_lbl'));

		// adding custom js in admin side
		add_action( 'admin_enqueue_scripts', array($this,'cmc_admin_custom_js'));
		// rest api endpoint for sitemap generation 
		add_action('rest_api_init', function () {
			register_rest_route('coin-market-cap/v1', 'sitemap.xml', array(
				'methods' => 'GET',
				'callback' => array($this,'cmc_generate_sitemap')
			));

			register_rest_route('coin-market-cap/v1', 'update-coin-meta', array(
				'methods' => 'GET',
				'callback' => array($this,'cmc_update_coin_meta')
			));

		});

		if(is_admin()){
			// notice for review
			add_action( 'admin_init',array($this,'cmc_check_installation_time'));
		    add_action( 'admin_init',array($this,'cmc_spare_me'), 5 );

		    // registering meta boxes for shortcode
			add_action( 'add_meta_boxes', array( $this,'register_cmc_meta_box') );

			// custom columns for all shortcodes
			add_filter( 'manage_cmc_posts_columns',array($this,'set_custom_edit_cmc_columns'));
			add_action( 'manage_cmc_posts_custom_column' ,array($this,'custom_cmc_column'), 10, 2 );
			// coin descriptoin custom column
			add_filter( 'manage_cmc-description_posts_columns', array($this, 'set_custom_cmc_id_column' ));
			add_action( 'manage_cmc-description_posts_custom_column' , array($this,'cmc_id_column'), 10, 2 );

			add_action( 'save_post', array( $this,'save_cmc_settings'),10, 3 );
			add_action( 'add_meta_boxes_cmc',array($this,'cmc_add_meta_boxes'));

			//automatic updates
			require_once(dirname(__FILE__) . "/includes/class.wp-auto-plugin-update.php");
		
			add_action( 'admin_footer',  array($this, 'cmc_create_extract_ajax' ) );
			add_action( 'admin_notices', array($this,'cmc_admin_notice_for_coins_logo'));
			add_action( 'wp_ajax_cmc_extract_coins_icons', array( $this, 'cmc_extract_images') );

		}
		else{
			add_action('init',array($this,'cmc_grab_custom_slug'));
		}
		// disabling jetpack photon cache
		add_filter( 'jetpack_photon_skip_for_url',array( $this,'cmc_photon_only_allow_local'), 9, 4 );

		if(is_admin()){
         add_action( 'admin_enqueue_scripts', array( $this,'cmc_remove_wp_colorpicker'),99);
		}
		
		add_filter('cron_schedules', array($this, 'cmc_cron_schedules')); 
		add_action('cmc_coins_autosave', array($this, 'do_this_5minutes_updates'));
		add_action('cmc_coins_weeklyprice_autosave', array($this, 'do_this_daily'));
		add_action('cmc_coins_meta_autosave', array($this, 'do_this_monthly'));
		add_action('cmc_coins_desc_autosave', array($this, 'cmc_save_this_monthly'));
	}

	function cmc_css_preload($html, $handle, $href, $media) {
	
		$preload_style = array(
			'cmc-global-style',
			'cmc-tab-design-custom',
			'cmc-bootstrap',
			'cmc-icons',
		);
		
		if ( in_array( $handle, $preload_style ) ) {
		 $html = "<link rel='preload' as='style' onload='this.onload=null;this.rel=\"stylesheet\"' id='$handle' href='$href' type='text/css' media='all' />";
		}

		return $html;
	}

		function cmc_defer_scripts( $tag, $handle, $src ) {
	
		// The handles of the enqueued scripts we want to defer
		$defer_scripts = array(
			'amcharts',
			'amcharts-stock',
			'amcharts-serial',
			'cmc-single-js'
		);

		// The handles of the enqueued scripts we want to async
		$async_scripts = array( 
			
			'cmc-bootstrap',
			'cmc-admin-custom-js',
			'ccc-socket',
			'ccc_stream',
			'cmc-custom',

		);
	
		if ( in_array( $handle, $async_scripts ) ) {
			return '<script src="' . $src . '" async="async" type="text/javascript"></script>' . "\n";
		}
		
		if ( in_array( $handle, $defer_scripts ) ) {
			return '<script src="' . $src . '" defer="defer" type="text/javascript"></script>' . "\n";
		}
		
		return $tag;
	}

/*
|--------------------------------------------------------------------------
|Load plugin function files here.
|--------------------------------------------------------------------------
*/
	public function cmc_includes()
	{
	require_once( 'titan-framework/titan-framework-embedder.php');
	require_once(CMC_PATH . '/includes/cmc-db.php');
	require_once(CMC_PATH . '/includes/cmc-coins-db.php');
	require_once(CMC_PATH . '/includes/cmc-coins-meta-db.php');		
	require_once(CMC_PATH.'/includes/cmc-functions.php');
	require_once(CMC_PATH . '/includes/cmc-helpers.php');
	require_once(CMC_PATH . '/includes/cmc-shortcode.php');
	require_once(CMC_PATH . '/includes/cmc-top-shortcode.php');
	require_once(CMC_PATH . '/includes/cmc-advanced-single-shortcode.php');
	require_once(CMC_PATH . '/includes/cmc-single-shortcode.php');
	require_once(CMC_PATH . 'includes/init-api.php');
	$this->shortcode_cmc=new CMC_Shortcode();
	$this->cmc_gainer_losers=new CMC_Top();
	$this->shortcode_cmc_single=new CMC_Single_Shortcode();
	$this->shortcode_cmc_advanced_single = new CMC_Advanced_Single_Shortcode();
	}



	/**
	 * Code you want to run when all other plugins loaded.
	 */
	public function cmc_init() {
		load_plugin_textdomain( 'cmc', false, basename(dirname(__FILE__)) . '/languages/');
	}

/*
|--------------------------------------------------------------------------
|generating rewrite rule on plugin init
|--------------------------------------------------------------------------
*/
 function cmc_rewrite_rule() {
		$page_id= cmc_get_coins_details_page_id(); //get_option('cmc-coin-single-page-selected-design');
		$single_page_slug=cmc_get_page_slug();
		add_rewrite_rule('^' . $single_page_slug . '/([^/]*)/([^/]*)/([^/]*)?$', 'index.php?page_id=' . $page_id . '&coin_symbol=$matches[1]&coin_id=$matches[2]
		 	 &currency=$matches[3]
		 	', 'top');
		add_rewrite_rule('^'.$single_page_slug . '/([^/]*)/([^/]*)/?$', 'index.php?page_id=' . $page_id . '&coin_symbol=$matches[1]&coin_id=$matches[2]
', 'top');
		
		}

/*
|--------------------------------------------------------------------------
| adding dyanmic rewrite rule after save changes in slug settings 	
|--------------------------------------------------------------------------
*/

	function cmc_dynamic_rewrite_rules($wp_rewrite)
	{
		$page_id = cmc_get_coins_details_page_id();//get_option('cmc-coin-single-page-selected-design');
		$single_page_slug = cmc_get_page_slug();
		$feed_rules = array(
			'^' . $single_page_slug . '/([^/]*)/([^/]*)/([^/]*)/?$' => 'index.php?page_id=' . $page_id . '&coin_symbol=$matches[1]&coin_id=$matches[2]
		 	 &currency=$matches[3]',
			'^' . $single_page_slug . '/([^/]*)/([^/]*)/?$' => 'index.php?page_id=' . $page_id . '&coin_symbol=$matches[1]&coin_id=$matches[2]',
		);
		$wp_rewrite->rules = $feed_rules + $wp_rewrite->rules;
		return $wp_rewrite->rules;
	}
/*
|--------------------------------------------------------------------------
| adding query var for custom rewrite rules
|--------------------------------------------------------------------------
*/
function cmc_query_vars( $query_vars ){
			$query_vars[] = 'coin_symbol';
			$query_vars[] = 'coin_id';
			$query_vars[] ='currency';
			return $query_vars;
		}

/*
|--------------------------------------------------------------------------
| generating page with shortcode for coin single page
|--------------------------------------------------------------------------
*/		
function add_coin_details_page(){
		 	$post_data = array(
		    'post_title' => 'CMC Currency Details',
		    'post_type' => 'page',
			'post_content'=>'
				[cmc-dynamic-title]
				[cmc-dynamic-description]
				[cmc-affiliate-link]
				[coin-market-cap-details]
				[cmc-coin-extra-data]
				<h3 class="single-page-h3">Crypto Calculator</h3>
				[cmc-calculator]
				<h3 class="single-page-h3">Price Chart</h3>
				[cmc-chart]
				<h3 class="single-page-h3">More Info About Coin</h3>
				[coin-market-cap-description]
				<h3 class="single-page-h3">Historical Data</h3>
				[cmc-history]
				<h3 class="single-page-h3">Markets / Exchanges</h3>
				<div class="specialline">**You can show markets data only by installing "Cryptocurrency Exchanges List Pro" WordPress plugin with "Coin Market Cap &amp; Price" plugin.</div>
				[celp-coin-exchanges]
				<h3 class="single-page-h3">Technical Analysis</h3>
				[cmc-technical-analysis autosize="true" theme="light"]
				<h3 class="single-page-h3">Twitter News Feed</h3>
				[cmc-twitter-feed]
				<h3 class="single-page-h3">Submit Your Reviews</h3>
				[coin-market-cap-comments]',
		     'post_status'   => 'publish',
		      'post_author'  => get_current_user_id(),
			);

			$single_page_id = get_option('cmc-coin-single-page-id');

			if('publish' === get_post_status( $single_page_id)){
			
			}else{
				$post_id = wp_insert_post( $post_data );
			update_option('cmc-coin-single-page-id',$post_id);
			}

			$post_data = array(
				'post_title'	=>	'CMC Currency Details (Advanced Design)',
				'post_type'		=>	'page',
				'post_content'	=>'
				[cmc-single-coin-details-advanced-design]
				',
				'post_status'	=>	'publish',
				'post_author'	=> get_current_user_id()
			);
			
			$single_page_id = get_option('cmc-coin-advanced-single-page-id');

			if('publish' === get_post_status( $single_page_id)){
			
			}else{
				$post_id = wp_insert_post( $post_data );
				update_option('cmc-coin-advanced-single-page-id',$post_id);
			}

 		}
/*
|--------------------------------------------------------------------------
| generating coins tables
|--------------------------------------------------------------------------
 */
 function cmc_create_table(){
	 			add_option('cmc_table_init','1');
				$cmc_db = new CMC_Coins;
				$cmc_details_db = new CMC_Coins_Meta;
				$cmc_db->create_table();
				$cmc_details_db->create_table();
				delete_option('cmc_table_init');
		 }
/*
|--------------------------------------------------------------------------
| deleting coins tables on plugin deactivation
|--------------------------------------------------------------------------
 */		 
		 function cmc_delete_table(){
			global $wpdb;
			$coin_table = $wpdb->prefix . 'cmc_coins';
			$coin_meta_table = $wpdb->prefix . 'cmc_coin_meta';
			$wpdb->query("DROP TABLE IF EXISTS " . $coin_table);
			$wpdb->query("DROP TABLE IF EXISTS " . $coin_meta_table);
		 }
/*
|--------------------------------------------------------------------------
|  Plugin settings panel
|--------------------------------------------------------------------------
 */		 
	function cmc_createMyOptions(){
		require_once CMC_PLUGIN_DIR .'/includes/cmc-settings.php';
	}


	
/*
|--------------------------------------------------------------------------
| CMC post type for generate shortcode settings panel
|--------------------------------------------------------------------------
 */			
	function cmc_post_type() {

		$labels = array(
			'name'                  => _x( 'Coin Market Cap', 'Post Type General Name', 'cmc2' ),
			'singular_name'         => _x( 'Coin Market Cap', 'Post Type Singular Name', 'cmc2' ),
			'menu_name'             => __( 'Coin Market Cap', 'cmc2' ),
			'name_admin_bar'        => __( 'Coin Market Cap', 'cmc2' ),
			'archives'              => __( 'Item Archives', 'cmc2' ),
			'attributes'            => __( 'Item Attributes', 'cmc2' ),
			'parent_item_colon'     => __( 'Parent Item:', 'cmc2' ),
			'all_items'             => __( 'All Shortcodes', 'cmc2' ),
			'add_new_item'          => __( 'Add New Shortcode', 'cmc2' ),
			'add_new'               => __( 'Add New', 'cmc2' ),
			'new_item'              => __( 'New Item', 'cmc2' ),
			'edit_item'             => __( 'Edit Item', 'cmc2' ),
			'update_item'           => __( 'Update Item', 'cmc2' ),
			'view_item'             => __( 'View Item', 'cmc2' ),
			'view_items'            => __( 'View Items', 'cmc2' ),
			'search_items'          => __( 'Search Item', 'cmc2' ),
			'not_found'             => __( 'Not found', 'cmc2' ),
			'not_found_in_trash'    => __( 'Not found in Trash', 'cmc2' ),
			'featured_image'        => __( 'Featured Image', 'cmc2' ),
			'set_featured_image'    => __( 'Set featured image', 'cmc2' ),
			'remove_featured_image' => __( 'Remove featured image', 'cmc2' ),
			'use_featured_image'    => __( 'Use as featured image', 'cmc2' ),
			'insert_into_item'      => __( 'Insert into item', 'cmc2' ),
			'uploaded_to_this_item' => __( 'Uploaded to this item', 'cmc2' ),
			'items_list'            => __( 'Items list', 'cmc2' ),
			'items_list_navigation' => __( 'Items list navigation', 'cmc2' ),
			'filter_items_list'     => __( 'Filter items list', 'cmc2' ),
		);
		$args = array(
			'label'                 => __( 'CryptoCurrency Price Widget', 'cmc2' ),
			'description'           => __( 'Post Type Description', 'cmc2' ),
			'labels'                => $labels,
			'supports'              => array( 'title' ),
			'taxonomies'            => array(''),
			'hierarchical'          => false,
			'public' => false,  // it's not public, it shouldn't have it's own permalink, and so on
			'show_ui'               => true,
			'show_in_nav_menus' => false,  // you shouldn't be able to add it to menus
			'menu_position'         =>20,
			'show_in_admin_bar'     => true,
			'show_in_nav_menus'     => true,
			'can_export'            => true,
			'has_archive' => false,  // it shouldn't have archive page
			'rewrite' => false,  // it shouldn't have rewrite rules
			'exclude_from_search'   => true,
			'publicly_queryable'    => true,
			 'menu_icon'           => 'dashicons-chart-area',
			'capability_type'       => 'page',
		);
		register_post_type( 'cmc', $args );

	}

/*
|--------------------------------------------------------------------------
| Post meta for CMC shortcodes
|--------------------------------------------------------------------------
 */
		public	function register_cmc_meta_box()
			{
			add_meta_box( 'cmc-shortcode', 'Coin Market Cap shortcode',array($this,'cmc_shortcode_meta'), 'cmc', 'side', 'high' );
			}

		public	function cmc_shortcode_meta()
		{
	    $id = get_the_ID();
	    $dynamic_attr='';
	    echo '<p>Paste this shortcode in anywhere (page/post)</p>';
	   $dynamic_attr.="[coin-market-cap id=\"{$id}\"";
	   $dynamic_attr.=']';
	    ?>
	    <input type="text" class="cmc-regular-small" style="width:100%;text-align:center;" onClick="this.select();" name="cmc_meta_box_text" id="cmc_meta_box_text" value="<?php echo htmlentities($dynamic_attr) ;?>" readonly/>

	    <?php
		}

/*
|--------------------------------------------------------------------------
| All shortcodes custom columns
|--------------------------------------------------------------------------
 */
		 function set_custom_edit_cmc_columns($columns) {
	   	 $columns['shortcode'] = __( 'Shortcode', 'cmc2' );
	   return $columns;
		}

		function custom_cmc_column( $column, $post_id ) {
				switch ( $column ) {
			   case 'shortcode' :
					echo '<code>[coin-market-cap id="'.$post_id.'"]</code>';
					break;

			}
		}

	// description post type custom column 
	 function set_custom_cmc_id_column($currency_columns) {

		$currency_columns['coin_id'] = __( 'COIN ID', 'cmc2' );

		return $currency_columns;
		}
		
	 function cmc_id_column( $currency_columns, $post_id ) {
			$cmcd_id=get_the_ID();
			$meta = get_post_meta($cmcd_id, 'cmc_single_settings_des_coin_name', true);
			switch ( $currency_columns ) {
			case 'coin_id' :
			echo $meta;
			break;
				}
		}

/*
|--------------------------------------------------------------------------
| creating custom post type of coin custom description for coin single page
|--------------------------------------------------------------------------
 */		
	
function cmc_description_post_type() {

		$labels = array(
			'name'                  => _x( 'Coin Description', 'Post Type General Name', 'cmc2' ),
			'singular_name'         => _x( 'Coin Description', 'Post Type Singular Name', 'cmc2' ),
			'menu_name'             => __( 'Coin Description', 'cmc2' ),
			'name_admin_bar'        => __( 'Coin Description', 'cmc2' ),
			'archives'              => __( 'Item Archives', 'cmc2' ),
			'attributes'            => __( 'Item Attributes', 'cmc2' ),
			'parent_item_colon'     => __( 'Parent Item:', 'cmc2' ),
			'all_items'             => __( 'All Descriptions', 'cmc2' ),
			'add_new_item'          => __( 'Add New Description', 'cmc2' ),
			'add_new'               => __( 'Add New', 'cmc2' ),
			'new_item'              => __( 'New Item', 'cmc2' ),
			'edit_item'             => __( 'Edit Item', 'cmc2' ),
			'update_item'           => __( 'Update Item', 'cmc2' ),
			'view_item'             => __( 'View Item', 'cmc2' ),
			'view_items'            => __( 'View Items', 'cmc2' ),
			'search_items'          => __( 'Search Item', 'cmc2' ),
			'not_found'             => __( 'Not found', 'cmc2' ),
			'not_found_in_trash'    => __( 'Not found in Trash', 'cmc2' ),
			'featured_image'        => __( 'Featured Image', 'cmc2' ),
			'set_featured_image'    => __( 'Set featured image', 'cmc2' ),
			'remove_featured_image' => __( 'Remove featured image', 'cmc2' ),
			'use_featured_image'    => __( 'Use as featured image', 'cmc2' ),
			'insert_into_item'      => __( 'Insert into item', 'cmc2' ),
			'uploaded_to_this_item' => __( 'Uploaded to this item', 'cmc2' ),
			'items_list'            => __( 'Items list', 'cmc2' ),
			'items_list_navigation' => __( 'Items list navigation', 'cmc2' ),
			'filter_items_list'     => __( 'Filter items list', 'cmc2' ),
		);
		$args = array(
			'label'                 => __( 'Coin Description', 'cmc2' ),
			'description'           => __( 'Post Type Description', 'cmc2' ),
			'labels'                => $labels,
			'supports'              => array( 'title' ),
			'taxonomies'            => array(''),
			'hierarchical'          => false,
			'public' => false,  // it's not public, it shouldn't have it's own permalink, and so on
			'show_ui'               => true,
			'show_in_nav_menus' => false,  // you shouldn't be able to add it to menus
			'menu_position'         =>20,
			'show_in_admin_bar'     => true,
			'show_in_nav_menus'     => true,
			'can_export'            => true,
			'has_archive' => false,  // it shouldn't have archive page
			'rewrite' => false,  // it shouldn't have rewrite rules
			'exclude_from_search'   => true,
			'publicly_queryable'    => true,
			 'menu_icon'           => 'dashicons-chart-area',
			'capability_type'       => 'page',

		);
		register_post_type( 'cmc-description', $args );


}


	/*
	For ask for reviews code
	*/

	function cmc_installation_date(){
		 $get_installation_time = strtotime("now");
   	 	  add_option('cmc_activation_time', $get_installation_time );
	}

	//check if review notice should be shown or not

	function cmc_check_installation_time() {

		$spare_me = get_option('cmcc_spare_me');
	    if($spare_me!=1){
	        $install_date = get_option( 'cmc_activation_time' );
			$past_date = strtotime( '-1 days' );
		  if ( $past_date >= $install_date ) {
	     	 add_action( 'admin_notices', array($this,'cmc_display_admin_notice'));
	     		}
	    }
	}

	/**
	* Display Admin Notice, asking for a review
	**/
	function cmc_display_admin_notice() {
	    // wordpress global variable
	    global $pagenow;
	
	        $dont_disturb = esc_url( get_admin_url() . '?cmcc_spare_me=1' );
	        $plugin_info = get_plugin_data( __FILE__ , true, true );
	        $reviewurl = esc_url( 'https://codecanyon.net/item/coin-market-cap-prices-wordpress-cryptocurrency-plugin/reviews/21429844' );

 printf(__('<style>.ctf_review_notice {display:none !Important;}</style><div class="cmc-review wrap" style="background: #ffffff !important;border-left: 4px solid #ffba00;padding: 15px !important;max-width: 860px;display: inline-block;border-radius: 4px;clear:both;-webkit-box-shadow: 0 1px 1px 0 rgba(0,0,0,.1);box-shadow: 0 1px 1px 0 rgba(0,0,0,.1);">
 <img style="display: inline;float: left;margin-right: 14px;border: 4px solid #e7e2ce;border-radius: 3px;" src="'.plugin_dir_url(__FILE__).'images/coinmarketcap-logo.png" />
 <p style="display: inline;vertical-align: top;">You have been using <b> %s </b> plugin for a while. We hope you liked it ! Please give us a quick rating, it works as a boost for us to keep working on the plugin updates & new features !</br></br><a href="%s" class="button button-primary" target=
	            "_blank">Rate Now!</a><a href="%s" class="ccpw-review-done button button-secondary" style="margin-left: 10px !important;"> Already Done !</a><a href="%s" class="ccpw-review-done button button-secondary" style="margin-left: 10px !important;"> Not Interested !</a></p></div>', $plugin_info['TextDomain']), $plugin_info['Name'], $reviewurl, $dont_disturb,$dont_disturb );



	}

    // remove the notice for the user if review already done or if the user does not want to
	function cmc_spare_me(){
	    if( isset( $_GET['cmcc_spare_me'] ) && !empty( $_GET['cmcc_spare_me'] ) ){
			$spare_me = $_GET['cmcc_spare_me'];
	        if( $spare_me== 1 ){
	            update_option( 'cmcc_spare_me',1);
	        }
	    }
	}


/*
|--------------------------------------------------------------------------
| Plugin feedback meta boxes
|--------------------------------------------------------------------------
*/	
	function cmc_add_meta_boxes($post){
		add_meta_box(
                'cmc-feedback-section',
                __( 'Hopefully you are Happy with our plugin','cmc2'),
                array($this,'cmc_right_section'),
                'cmc',
                'side',
                'low'
            );
	}
	// ask for review notice 
	function cmc_right_section($post, $callback){
        global $post;
        $pro_add='';
        $pro_add .=
        __('May I ask you to give it a 5-star rating on  ','cmc2'). '<strong><a target="_blank" href="https://codecanyon.net/item/coin-market-cap-prices-wordpress-cryptocurrency-plugin/reviews/21429844">'.__('Codecanyon','cmc2').'</a></strong>?'.'<br/>'.
         __('This will help to spread its popularity and to make this plugin a better one on  ','cmc2').
        '<strong><a target="_blank" href="https://codecanyon.net/item/coin-market-cap-prices-wordpress-cryptocurrency-plugin/reviews/21429844">'.__('Codecanyon','cmc2').'</a></strong><br/>
        <a target="_blank" href="https://codecanyon.net/item/coin-market-cap-prices-wordpress-cryptocurrency-plugin/reviews/21429844"><img src="https://res.cloudinary.com/cooltimeline/image/upload/v1504097450/stars5_gtc1rg.png"></a>
      <div><a href="https://coinmarketcapinfo.com/plugin/" target="_blank">'.__('View Demos','cmc2').'</a></div><br/>
         <div>
		<iframe src="https://www.facebook.com/plugins/like.php?href=http%3A%2F%2Fcryptowidget.coolplugins.net&width=122&layout=button&action=like&size=large&show_faces=false&share=true&height=65&appId=1798381030436021" width="122" height="65" style="border:none;overflow:hidden" scrolling="no" frameborder="0" allowTransparency="true"></iframe></div>';
        echo $pro_add ;

    }



		/**
	 * Save shortcode when a post is saved.
	 *
	 * @param int $post_id The post ID.
	 * @param post $post The post object.
	 * @param bool $update Whether this is an existing post being updated or not.
	 */
function save_cmc_settings( $post_id, $post, $update ) {
	// Autosave, do nothing
		if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE )
		        return;
		// AJAX? Not used here
		if ( defined( 'DOING_AJAX' ) && DOING_AJAX )
		        return;
		// Check user permissions
		if ( ! current_user_can( 'edit_post', $post_id ) )
		        return;
		// Return if it's a post revision
		if ( false !== wp_is_post_revision( $post_id ) )
		        return;
    /*
     * In production code, $slug should be set only once in the plugin,
     * preferably as a class property, rather than in each function that needs it.
     */
    $post_type = get_post_type($post_id);

    // If this isn't a 'book' post, don't update it.
    if ( "cmc" != $post_type ) return;
	    // - Update the post's metadata.
   		 update_option('cmc-post-id',$post_id);


	}
	

	/**
	 * Only use Photon for images belonging to our site.
	 * @param bool         $skip      Should Photon ignore that image.
	 * @param string       $image_url Image URL.
	 * @param array|string $args      Array of Photon arguments.
	 * @param string|null  $scheme    Image scheme. Default to null.
	 */
	function cmc_photon_only_allow_local( $skip, $image_url, $args, $scheme ) {
	    // Get the site URL, without any protocol.
	    $site_url = preg_replace( '~^(?:f|ht)tps?://~i', '', get_site_url() );
	 
	    /**
	     * If the image URL is from our site,
	     * return default value (false, unless another function overwrites).
	     * Otherwise, do not use Photon with it.
	     */
	    if ( strpos( $image_url, $site_url ) ) {
	        return $skip;
	    } else {
	        return true;
	    }
	}


	// attaching hook after titan settings save
	function cmc_after_titan_save($container, $activeTab, $options)
	{
		$cmc_titan = TitanFramework::getInstance('cmc_single_settings');
		$slug = $cmc_titan->getOption('single-page-slug');
		$details_page 	 = $cmc_titan->getOption('single-page-design-id');
	//	set_transient('cmc-single-page-slug', $slug,MINUTE_IN_SECONDS );
		update_option('cmc-single-page-slug', $slug);

			if( !isset( $details_page ) || $details_page == false ){
				$details_page = get_option( 'cmc-coin-single-page-id' );
			}
			update_option('cmc-coin-single-page-selected-design',$details_page);

	if (isset($_REQUEST['tab']) && $_REQUEST['tab'] == "extra-settings") {
			add_filter('generate_rewrite_rules',array($this, 'cmc_dynamic_rewrite_rules'));
			flush_rewrite_rules();
		}

	}

	function cmc_grab_custom_slug(){
				$cmc_titan = TitanFramework::getInstance('cmc_single_settings');
				$slug = $cmc_titan->getOption('single-page-slug');
				//set_transient('cmc-single-page-slug', $slug, MINUTE_IN_SECONDS);
				update_option('cmc-single-page-slug', $slug);
	

	}

	// registering custom js for settings panel
	function cmc_admin_custom_js()
	{
	  
	 	$screen =(array) get_current_screen();
	 
	    if (isset($screen['post_type']) && $screen['post_type']=="cmc") {     
	    // loading js
	   wp_register_script( 'cmc-admin-custom-js', CMC_URL.'assets/js/cmc-admin-custom.js', array('jquery-core'), CMC, true );
	    wp_enqueue_script( 'cmc-admin-custom-js' );
		}
	}

/*
|--------------------------------------------------------------------------
| generating sitemap 
|--------------------------------------------------------------------------
 */
	function cmc_update_coin_meta(){
			$rs=save_cmc_extra_data();
			update_option('cmc-coins-meta-saving-time', time() );
		//	if($rs){
			$timing=MONTH_IN_SECONDS;
			set_transient('cmc-saved-extradata', date('d/m H:s:i'),$timing);
			$response['coin-meta-data'] ='generated';
			//}

			//fetching coin full description 
			$rs2=save_coin_desc_data();
			update_option('cmc-coins-desc-saving-time', time() );
			if($rs2){
			$timing=MONTH_IN_SECONDS;
			set_transient('cmc-saved-desc', date('d/m H:s:i'), $timing);
			$response['coin-description-data'] ='generated';
			}
			$response['status'] ="success";

			echo json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES);
			die();
			
	}

	function cmc_generate_sitemap(){

        /*---- Create Coin Market Cap sitemap Upload / Download Directories on Plugin Activate ----*/
        $upload = wp_upload_dir();
        $upload_dir = $upload['basedir'];
        $upload_dir = $upload_dir . '/cmc';
        $sitemap_dir = $upload_dir . '/cmc/sitemap';

        if (! is_dir($upload_dir)) {
            mkdir( $upload_dir );           
        }
        if(! is_dir($upload_dir.'/sitemap')){
            mkdir( $upload_dir.'/sitemap' );
        }

		$fetch_coins = 500;
		$start_point = 0;
		$old_currency="USD";
		$cmc_coins_page=1;
		$response=array();
		$per_page =50;
		$cmcDB = new CMC_Coins;
		$first_500_coin_data = $cmcDB->get_coins( array("number"=>500,'offset'=> 0));
		$second_500_coin_data = $cmcDB->get_coins( array("number"=>500,'offset'=>499));
		$third_500_coin_data = $cmcDB->get_coins( array("number"=>500,'offset'=> 999));
        $fourth_500_coin_data = $cmcDB->get_coins( array("number"=>500,'offset'=> 1500));
        
        $sitemap_url = home_url('wp-content/uploads/cmc/sitemap/', '/');
        

		if (is_array($first_500_coin_data) && count($first_500_coin_data) > 0) {
			$response['status'] = array('status' => 'Successfully Generated Sitemap',
			'message'=>'Please copy these links and submit to search engines.'
		);
			$this->cmc_create_sitemap($first_500_coin_data,1,500);
			$this->cmc_create_sitemap($second_500_coin_data,2,500);
			$this->cmc_create_sitemap($third_500_coin_data,3,500);
			$this->cmc_create_sitemap($fourth_500_coin_data,4,500);

			$combine_sitemap = "<?xml version='1.0' encoding='UTF-8'?>";
			$combine_sitemap .= "<sitemapindex xmlns='http://www.sitemaps.org/schemas/sitemap/0.9'>";

				$combine_sitemap .= "<sitemap>";
					$combine_sitemap .=	"<loc>". $sitemap_url . 'sitemap-1.xml' ."</loc>";
					$combine_sitemap .= "</sitemap>";
					$combine_sitemap .= "<sitemap>";
					$combine_sitemap .=	"<loc>". $sitemap_url . 'sitemap-2.xml' ."</loc>";
					$combine_sitemap .= "</sitemap>";
					$combine_sitemap .= "<sitemap>";
					$combine_sitemap .=	"<loc>". $sitemap_url . 'sitemap-3.xml' ."</loc>";
					$combine_sitemap .= "</sitemap>";
					$combine_sitemap .= "<sitemap>";
					$combine_sitemap .=	"<loc>". $sitemap_url . 'sitemap-4.xml' ."</loc>";
					$combine_sitemap .= "</sitemap>";
			$combine_sitemap .= "</sitemapindex>";

			header('content-type: text/xml');
			echo $combine_sitemap;
					die();
		} else {
			$response[] = array('status' => 'Error',
				'error'=> 'API Request Timeout'
			);
			echo $rs = json_encode($response, JSON_PRETTY_PRINT | JSON_UNESCAPED_SLASHES);
			die();
		}


	}	
	//coins sitemap XML generator 
	function cmc_create_sitemap($all_coin_data, $cmc_coins_page, $per_page){
				$coins_xml = '';
				$sitemap = '';
                $show_coins = $all_coin_data; 
                $upload = wp_upload_dir();
                $upload_dir = $upload['basedir'];
                $sitemap_dir = $upload_dir . '/cmc/sitemap';

				if (is_array($show_coins) && count($show_coins) > 0) {
					foreach ($show_coins as $coin) {
						$coin = (array)$coin;
						$coin_id = $coin['coin_id'];
						$coin_symbol = $coin['symbol'];
						$single_page_slug = cmc_get_page_slug();
						$coin_url = esc_url(home_url($single_page_slug . '/' . $coin_symbol . '/' . $coin_id.'/', '/'));
						$static = '12';
						$coins_xml .= '<url>' .
							'<loc>' . $coin_url . '</loc>' .
							'<priority>1</priority>' .
							'<changefreq>daily</changefreq>' .
							'</url>';
					}
					$sitemap = '<?xml version="1.0" encoding="UTF-8"?>';
					$sitemap .= '<?xml-stylesheet type="text/xsl" href="' . CMC_URL . '/sitemap/sitemap-style.xsl"?>';
					$sitemap .= '<urlset xmlns="http://www.sitemaps.org/schemas/sitemap/0.9">';
					$sitemap .= $coins_xml;
					$sitemap .= '</urlset>';
					$fp = fopen($sitemap_dir . '/' . "sitemap-". $cmc_coins_page .".xml", 'w');
					fwrite($fp, $sitemap);
					fclose($fp);
				}
	}
		// custom label for auto generated page
		function cmc_generted_page_lbl($states){
			global $post;
			$post_status = get_post_status($post->ID);
			$custom_state = __("Don't Delete", 'cmc2');
			if ($post->ID == get_option('cmc-coin-single-page-id') || $post->ID == get_option('cmc-coin-advanced-single-page-id')) {
				if( $post_status == 'publish' )
				{
					return $states[] = array( $custom_state );
				}else{
					return $states[] = array( $post_status .', '.$custom_state );
				}
			}
			return $states;
		}

			// fixing conflict
			public function cmc_remove_wp_colorpicker()
			{
				wp_dequeue_script('wp-color-picker-alpha');
			}

	/*
|--------------------------------------------------------------------------
|   on plugin activation hook adding page and flushing rewrite rules
|--------------------------------------------------------------------------
 */		
	
public function cmc_activate()
{
	$this->add_coin_details_page();
	$CMC_VERSION = get_option('CMC_PRO_VERSION');
	if( $CMC_VERSION === false ){
		update_option('CMC_FRESH_INSTALLATION',CMC);
	}
	$this->cmc_rewrite_rule();
	$this->cmc_create_table();
	$this->cmc_cron_job_init();
	flush_rewrite_rules();
    

}		

/*
|--------------------------------------------------------------------------
|  Check if plugin is just updated from older version to new
|--------------------------------------------------------------------------
*/	
public function cmc_plugin_version_verify( ) {
	
	$CMC_VERSION = get_option('CMC_PRO_VERSION');
	if( !isset($CMC_VERSION) || version_compare( $CMC_VERSION, CMC, '<' ) ){
		$this->cmc_activate();
		update_option('CMC_PRO_VERSION', CMC );
	}
}	// end of cmc_plugin_version_verify()
			

/*
|--------------------------------------------------------------------------
|  Run when deactivate plugin.
|--------------------------------------------------------------------------
*/	
			public function cmc_deactivate()
			{
				if(!is_plugin_active( 'cryptocurrency-price-ticker-widget-pro/cryptocurrency-price-ticker-widget-pro.php' ) ) {
					$this->cmc_delete_table();
				}

				wp_clear_scheduled_hook('cmc_coins_autosave');
				wp_clear_scheduled_hook('cmc_coins_weeklyprice_autosave');
				wp_clear_scheduled_hook('cmc_coins_meta_autosave');
				wp_clear_scheduled_hook('cmc_coins_desc_autosave');
				delete_transient('cmc-saved-coindata');
				delete_transient('cmc-saved-weeklydata');
				delete_transient('cmc-saved-extradata');
				delete_transient('cmc-saved-desc');
				flush_rewrite_rules();
			}
/*
|--------------------------------------------------------------------------
|   on plugin activation hook adding page and flushing rewrite rules
|--------------------------------------------------------------------------
 */		
	public function cmc_cron_job_init(){

		if (!wp_next_scheduled('cmc_coins_autosave')) {
			wp_schedule_event(time(), '5min', 'cmc_coins_autosave');
		}
		if (!wp_next_scheduled('cmc_coins_weeklyprice_autosave')) {
			wp_schedule_event(time(), '12hour', 'cmc_coins_weeklyprice_autosave');
		}
		if (!wp_next_scheduled('cmc_coins_meta_autosave')) {
			wp_schedule_event(time(), 'monthly', 'cmc_coins_meta_autosave');
		}
		if (!wp_next_scheduled('cmc_coins_desc_autosave')) {
			wp_schedule_event(time(), 'monthly', 'cmc_coins_desc_autosave');
		}
	}
/*
|--------------------------------------------------------------------------
|  cron custom schedules
|--------------------------------------------------------------------------
 */
			function cmc_cron_schedules($schedules)
			{
				// 5 minute schedule for grabing all coins 
				if (!isset($schedules["5min"])) {
					$schedules["5min"] = array(
						'interval' => 5 * 60,
						'display' => __('Once every 5 minutes')
					);
				}
				if (!isset($schedules["12hour"])) {
					$schedules["12hour"] = array(
						'interval' =>43200,
						'display' => __('Once every 12 hours')
					);
				}
				if (!isset($schedules["monthly"])) {
				$schedules['monthly'] = array(
					'interval' => 2635200,
					'display' => __('Once a month')
				);
				}
				return $schedules;
			}
/*
|--------------------------------------------------------------------------
|  grabing coins data after 5 minute using cron
|--------------------------------------------------------------------------
 */

			function do_this_5minutes_updates()
			{
				$timing=5 * MINUTE_IN_SECONDS;
				//saving all coins data
				$rs=save_cmc_coins_data();
				if($rs){
				set_transient('cmc-saved-coindata', date('H:s:i'),$timing);
				set_transient('cmc-saved-in','cron',$timing);
				}
			
			}
/*
|--------------------------------------------------------------------------
| //grabing coin weekly price data(historical)for small charts
|--------------------------------------------------------------------------
 */			
			function do_this_daily()
			{
				$rs=save_cmc_historical_data();
				$timing=12 * HOUR_IN_SECONDS;
				set_transient('cmc-saved-weeklydata', date('H:s:i'), $timing);
				
			}

/*
|--------------------------------------------------------------------------
| //grabing coin soical links and extra info
|--------------------------------------------------------------------------
 */
		function do_this_monthly()
		{
			$rs=save_cmc_extra_data();
			$timing=MONTH_IN_SECONDS;
			set_transient('cmc-saved-extradata', date('d/m H:s:i'), $timing);
			
		}
		function cmc_save_this_monthly()
		{
			//fetching coin full description 
			$rs=save_coin_desc_data();
			$timing=MONTH_IN_SECONDS;
			set_transient('cmc-saved-desc', date('d/m H:s:i'), $timing);
				
		}

		function cmc_admin_notice_for_coins_logo(){

			$plugin_info = get_plugin_data( __FILE__ , true, true );
			if( get_option("cmc_download_icons")!= CMC ){
				printf(__('<style>.ctf_review_notice {display:none !Important;}</style><div class="cmc-review wrap" style="background: #ffffff !important;border-left: 4px solid #ffba00;padding: 15px !important;max-width: 860px;display: inline-block;border-radius: 4px;clear:both;-webkit-box-shadow: 0 1px 1px 0 rgba(0,0,0,.1);box-shadow: 0 1px 1px 0 rgba(0,0,0,.1);">
	<p style="display: inline;vertical-align: top;">New coins added! Please update coin logos, links, description and sitemap from <strong>%s >> Coin Details Settings >> Extra Settings</strong> page.</p></div>'),$plugin_info['Name'] );
			}

		}
		/*
		|-------------------------------------------------------------------------------|
		|			Add javascript into head for ajax calls.							|
		|-------------------------------------------------------------------------------|
		*/
		function cmc_create_extract_ajax(){
			wp_enqueue_script('jquery');
			?>
				<script>
					(function($){
					
					$('#cmc_refresh_coins_logo').on('click',function(evt){
						evt.preventDefault();
						var cmc_icons_url = "<?php echo admin_url( 'admin-ajax.php' ); ?>";
						var small = {'action':'cmc_extract_coins_icons','choice':'1'};
						var large = {'action':'cmc_extract_coins_icons','choice':'2'};
						small_icons_ajax = {
							data:small,
							url:cmc_icons_url,
							type:'POST',
							beforeSend:function(data){
								$('#cmc_refresh_coins_logo').text('Downloading...')	
								$('<p id="cmc_warning">It may take 3-5 minutes please don\'t close window now!<img src="<?php echo CMC_URL; ?>/images/chart-loading.svg"></p>').insertAfter('#cmc_refresh_coins_logo');
								$('#cmc_refresh_coins_logo').attr('id','cmc_downloading');
								$('#cmc_downloading').attr('disabled','disabled');
							}
						};
						large_icons_ajax = {
							data:large,
							url:cmc_icons_url,
							type:'POST',
							success:function(res){
								$('#cmc_downloading').text('Downloding Complete!');
								$("#cmc_warning").remove();
							}
						};
						$.when( $.ajax(small_icons_ajax),
							 $.ajax(large_icons_ajax)
						);
					});
					})(jQuery);
				</script>

			<?php
		}

		/*
		|-------------------------------------------------------------------------------------------|
		|		Download available icons and extract in upload folder.								|
		|		AJAX-CALL ONLY: DO NOT CALL THIS FUNCTION DIRECTLY.									|
		|-------------------------------------------------------------------------------------------|
		*/
		function cmc_extract_images(){
			
			set_time_limit(180);

			$choice = isset($_REQUEST['choice'])?$_REQUEST['choice']:'1';
			$cache = 'cmc_logo_update_'.$choice;
			
			if( get_transient($cache) != false ){
				return;
			}
			
			set_transient($cache, 'saving...'.$choice.' logos', HOUR_IN_SECONDS * 3 );

			switch($choice){
				case '1':
					$zip_url = "https://coolplugins.net/plugins-data/cmc/coins-icons-small.zip";
					$zip_file = '/small-icons.zip';
					$rename_file = array('old'=>'img32-compressed','new'=>'small-icons');
				break;
				case '2':
					$zip_url = "https://coolplugins.net/plugins-data/cmc/coins-icons-large.zip";
					$zip_file = '/large-icons.zip';
					$rename_file = array('old'=>'img128-compressed','new'=>'large-icons');
				break;
			}


			$upload_dir = wp_upload_dir(); // Set upload folder
			$upload_dir = $upload_dir['basedir'] . '/cmc/coins';
			
			$zip = new ZipArchive();
			
			if( !file_exists( $upload_dir ) ){
				mkdir( $upload_dir, 0755, TRUE );
			}
				
				copy($zip_url, $upload_dir.$zip_file);

			$res = $zip->open( $upload_dir . $zip_file);

			if ($res === TRUE) {

				if( !file_exists( $upload_dir ) ){
					mkdir( CMC_PATH . "extract");
				}
				$zip->extractTo( $upload_dir );

				if( file_exists( $upload_dir.'/'.$rename_file['new'] ) ){
					array_map('unlink', array_filter( 
						(array) array_merge(glob( $upload_dir.'/'.$rename_file['new'].'/*' )))); 
						rmdir( $upload_dir.'/'.$rename_file['new'] );
				}

				rename( $upload_dir.'/'.$rename_file['old'], $upload_dir.'/'.$rename_file['new'] );

				$zip->close();

				unlink( $upload_dir.$zip_file);

			} else {
				error_log('something went wrong' );
			}
			if( $choice=="2" ){
				update_option("cmc_download_icons", CMC );
			}

			die( json_encode(array('response'=>'Coins logo updated') ));
		}

		/*
		|------------------------------------------------------------
		|	Get current selected page id for coin details page from Titan Framework
		|	and save in wp_options
		|------------------------------------------------------------
		*/
	/* 	function cmc_save_coins_details_page_id(){
			
			$cmc_titan		 = TitanFramework::getInstance('cmc_single_settings');
			$details_page 	 = $cmc_titan->getOption('single-page-design-id');
			if( !isset( $details_page ) || $details_page == false ){
				$details_page = get_option( 'cmc-coin-single-page-id' );
			}
			update_option('cmc-coin-single-page-selected-design',$details_page);
		} */

} // class end

	function CoinMarketCap() {
		return CoinMarketCap::get_instance();
	}



$GLOBALS['CoinMarketCap'] = CoinMarketCap();
