<?php
class CMC_Top{

	function __construct(){
		require_once(CMC_PATH.'/includes/cmc-functions.php');
		require_once(CMC_PATH . '/includes/cmc-helpers.php');
		add_action( 'wp_enqueue_scripts','cmc_register_scripts');
		add_shortcode('cmc-top',array($this,'cmc_top_gainer_losers_shortcode'));
	}

	function cmc_top_gainer_losers_shortcode($atts, $content = null)
	{
		
		$atts = shortcode_atts( array(
		'id'  => '',
		'type'=>'gainers',
		'layout'=>'basic',
		'currency'=>'USD',
		'show-coins'=>30,
		), $atts);
		$topclass='';
		$topclass='';
		$output='';
		wp_enqueue_style( 'cmc-bootstrap');
		wp_enqueue_style( 'cmc-custom');
		wp_enqueue_script('cmc-datatables');
	/*	wp_add_inline_script( 'cmc-datatables', 'jQuery(document).ready( function($) {
			$(".cmc-gainer-lossers").each(function(index){
				$(this).dataTable({
					searching:false,
					paging:false,
				order:[],
				});
			}); 
		  });' ); */
		$inline_script='<script>
		jQuery(document).ready( function($) {
			$(".cmc-gainer-lossers").each(function(index){
				$(this).dataTable({
					searching:false,
					paging:false,
				order:[],
				});
			}); 
		  });
		</script>';
	
		$cmc_titan = TitanFramework::getInstance('cmc_single_settings');
		$change_sign_minus='-';
		$single_default_currency = $cmc_titan->getOption('default_currency');	
		$currency =$atts['currency'];
		$fiat_currency = $atts['currency'];
		$old_currency=isset($currency)? $currency :"USD";
		$load_only=!empty($atts['show-coins'])?$atts['show-coins']:30;
   		$type=$atts['type'];
		$bitcoin_price = get_transient('cmc_btc_price');
		$currency_symbol = cmc_old_cur_symbol($old_currency);
		$fiat_currency_rate= cmc_usd_conversions($old_currency);
	    $coins_data = cmc_get_top_coins($type,$load_only);
		$default_logo=CMC_URL.'assets/coins-logos/default-logo.png';	
if(is_array($coins_data)&& count($coins_data)>0){
	
	
		$output .='<div id="cryptocurency-market-cap-wrapper">
		<table id="cmc_top-gainer-lossers" class="table cmc-gainer-lossers cmc-top-'.$topclass.'  cmc-datatable table-striped table-bordered" width="100%">
		<thead><tr>';
		if($atts['layout']=="advance"){
		$output .='<th data-orderable="false" class="all" >'.__( '#', 'cmc' ).'</th>';
		}
		$output .='<th data-orderable="false" class="all">'.__( 'Name', 'cmc' ).'</th>';
		$output .='<th class="all">'.__( 'Price', 'cmc' ).'</th>';
		$output .='<th>'.__( 'Changes ', 'cmc' ).'<span class="badge  badge-default">'. __('24H', 'cmc' ).'</span></th>';

		if($atts['layout']=="advance"){
		$output .='<th>'.__( 'Market Cap', 'cmc' ).'</th>';
		$output .='<th>'.__( 'Volume ', 'cmc' ).'<span class="badge  badge-default">'.__('24H', 'cmc' ).'</span></th>';
	//	$output .='<th  data-orderable="false">'.__( 'Price Graph ', 'cmc' ).'<span class="badge badge-default">(24H)</span></th>';
		}
		$output .='</tr></thead><tbody>';
		$single_page_slug=cmc_get_page_slug();
		$i=0;
		 if(is_array($coins_data) ) {
		
foreach($coins_data as $coin ) {
					$coin = (array)$coin;
					$coin_id = $coin['coin_id'];
					$logo= coin_list_logo($coin['coin_id'], $size = 32);
					$coin_symbol = strtoupper($coin['symbol']);
					$rank = $i;
					$symbol = $coin_symbol;
					$coin_name = strtoupper($coin['name']);
					$coin_price = $coin['price'];
					$usd_market_cap= $coin['market_cap'];
					$usd_volume= $coin['total_volume'];
					$coin_html = '';
					if ($fiat_currency == "USD") {
						$coin_price = $coin['price'];
						$market_cap= $coin['market_cap'];
						$volume= $coin['total_volume'];
					} else if ($fiat_currency == "BTC") {
						$coin_price = $coin['price'] / $bitcoin_price;
						$market_cap = $coin['market_cap'] / $bitcoin_price;
						$volume = $coin['total_volume'] / $bitcoin_price;
					} else {
						$coin_price = $coin['price'] * $fiat_currency_rate;
						$market_cap = $coin['market_cap'] * $fiat_currency_rate;
						$volume = $coin['total_volume'] * $fiat_currency_rate;
					}
				
		$percent_change_24h= number_format($coin['percent_change_24h'],'2','.','');

	if($old_currency==$single_default_currency){
       	 $coin_url=esc_url( home_url($single_page_slug.'/'.$coin_symbol.'/'. $coin_id .'/','/') );
   		}else{
   		  $coin_url=esc_url( home_url($single_page_slug.'/'.$coin_symbol.'/'. $coin_id .'/'.$old_currency.'/','/') );
   		}
		$coin_link_open ='<a href="'.$coin_url.'">';
		$coin_link_close='</a>';
 		 $change_sign_24h ='<i class="cmc_icon-up" aria-hidden="true"></i>';
          $change_class_24h ='cmc-up';
         if ( strpos( $coin['percent_change_24h'], $change_sign_minus ) !==false) {
            $change_sign_24h = '<i class="cmc_icon-down" aria-hidden="true"></i>';
            $change_class_24h = 'cmc-down';
        }

			$changes_coin_html='';
			$changes_coin_html.='<span class="cmc-changes '.$change_class_24h.'">';
			$changes_coin_html.=$change_sign_24h.$percent_change_24h.'%' ;
			$changes_coin_html.= '</span>';
			$logo="<span class='cmc_coin_logo'><img onerror=\"this.src ='$default_logo'\" alt='$coin_id' src='$logo'></span>";
			
			$coin_symbol_html='<span class="cmc_coin_symbol">('.$coin_symbol.')</span><br/>';
			$coin_name_html='<span class="cmc_coin_name cmc-desktop">'.$coin_name.'</span>';
		$coin_html.='<tr data-coin-price="'.$coin['price'].'" data-coin-symbol="'.$coin_symbol.'">';

		if($atts['layout']=="advance"){
			$coin_html .='<td><span class="cmc_c_order">'.$i.'</span></td>';
		}
			$coin_html .='<td><span class="cmc-name">';
			$coin_html .=$coin_link_open.$logo.$coin_symbol_html.$coin_name_html.$coin_link_close;
			$coin_html .='</span></td>';
			$coin_html .='<td data-order="'.$coin_price.'"><span class="cmc-price">' . $currency_symbol . format_number($coin_price) . '</span></td>';
			$coin_html .='<td>'.$changes_coin_html.'</td>';

			if($atts['layout']=="advance"){
			$coin_html .='<td data-order="'.$market_cap.'" ><span class="cmc_live_cap">'.$currency_symbol .$formatted_market_cap.'</span></td>';
			$coin_html .='<td data-order="'.$volume.'" ><span class="cmc_live_vol">'.$currency_symbol .$formatted_volume.'</span></td>';
		//	$coin_html .='<td><div class="small-chart-area">'.$coin_link_open.get_coin_chart($coin_symbol).$coin_link_close.'</div></td>';
			}
	$coin_html.='</tr>';
	$output .= $coin_html;
			}
				
		} 
	$output .='</tbody></table></div>'.$inline_script;
	

} else {
	$output .= __('API Request timeout', 'cmc');
}
	return $output;

	}



	}
